<?php
// PHP script to parse anekdot.ru and produce rss feed from it's html.

// Feed settings
$titlenewsfeed="Anekdot.ru: лучшие анекдоты прошлых лет";
$urlwebsite="http://anekdot.ru/";
$description="Лучшие анекдоты этого дня за прошлые годы";
$yourname="Darsh";
$url = 'http://www.anekdot.ru/an/z/j3' . substr(date('Y'),3,1) . date('m'). date('d') . ';1.html';

// Inner HTML function
function DOMinnerHTML(DOMNode $element) {
    $innerHTML = "";
    $children  = $element->childNodes;
    foreach ($children as $child) {
        $innerHTML .= $element->ownerDocument->saveHTML($child);
    }
    return $innerHTML; 
}

$html = @DOMDocument::loadHTMLfile($url);

$xpath = new DOMXPath($html);

// Fetching elements for xml feed
$titles = $xpath->query('//div[@class="topicbox"]/p[@class="title"]');
$articles = $xpath->query('//div[@class="topicbox"]/div[@class="text"]');
$links = $xpath->query('//div[@class="topicbox"]/p[@class="title"]/a');

// Creating xml
$heading ="<item><title>";
$enddescr ="</description></item>";
$rssheader1 ="<?xml version=\"1.0\" encoding=\"UTF-8\"?><rss version=\"2.0\">\n<channel>\n<title>$titlenewsfeed</title>\n   
<link>$urlwebsite</link>
<description>$description</description>
<webMaster>$yourname</webMaster>
<language>ru</language>\n";
$rssfooter ="  \n</channel>\n</rss>\n";

echo $rssheader1;

for ($i = 0; $i < $titles->length; $i++) {
  echo "<item><title>";
  echo $titles->item($i)->nodeValue . " ";
  echo mb_substr($articles->item($i)->nodeValue,0,64,'UTF-8');
  echo "</title>";
  echo "<link>" . 'http://www.anekdot.ru' . $links->item($i)->getAttribute('href') . "</link>";
  echo "<description><![CDATA[" . DOMinnerHTML($articles->item($i)) . "]]></description></item>";
}
echo $rssfooter;

?>
