<?php
// PHP script to parse perashki.ru and produce rss feed from it's html.

// Feed settings
$titlenewsfeed="Пирожки";
$urlwebsite="http://perashki.ru/";
$description="Пирожковая";
$yourname="Darsh";
$url = 'http://www.perashki.ru/piro/all?sort=2';

// Inner HTML function
function DOMinnerHTML(DOMNode $element) {
    $innerHTML = "";
    $children  = $element->childNodes;
    foreach ($children as $child) {
        $innerHTML .= $element->ownerDocument->saveHTML($child);
    }
    return $innerHTML; 
}

$html = @DOMDocument::loadHTMLfile($url);

$xpath = new DOMXPath($html);

// Fetching elements for xml feed
$dates = $xpath->query('//div[@class="TextContainer"]/div[@class="Author"]/span[@class="date"]');
$author = $xpath->query('//div[@class="TextContainer"]/div[@class="Author"]');
$articles = $xpath->query('//div[@class="TextContainer"]/div[@class="Text"]');
$links = $xpath->query('//div[@class="MobileComments"]/a');

// Creating xml
$heading ="<item><title>";
$enddescr ="</description></item>";
$rssheader1 ="<?xml version=\"1.0\" encoding=\"UTF-8\"?><rss version=\"2.0\">\n<channel>\n<title>$titlenewsfeed</title>\n   
<link>$urlwebsite</link>
<description>$description</description>
<webMaster>$yourname</webMaster>
<language>ru</language>\n";
$rssfooter ="  \n</channel>\n</rss>\n";

echo $rssheader1;

for ($i = 0; $i < $articles->length; $i++) {
  echo "<item><title>";
  echo $dates->item($i)->nodeValue . " ";
  echo mb_substr($articles->item($i)->nodeValue,0,64,'UTF-8');
  echo "</title>";
  echo "<link>" . 'http://www.perashki.ru' . $links->item($i)->getAttribute('href') . "</link>";
  echo "<description><![CDATA[" . str_replace("\n","<br>",DOMinnerHTML($articles->item($i))) . "<br>" . $author->item($i)->nodeValue . "]]></description></item>";
}
echo $rssfooter;

?>
