<?php
// PHP script to parse echo.msk.ru and produce rss feed from it's html.

// Feed settings
$titlenewsfeed="Эхо Москвы: Всё так!";
$urlwebsite="http://echo.msk.ru/programs/vsetak/";
$description="Историческая программа Алексея Венедиктова и Натальи Басовской";
$yourname="Darsh";

// Inner HTML function
function DOMinnerHTML(DOMNode $element) {
    $innerHTML = "";
    $children  = $element->childNodes;
    foreach ($children as $child) {
        $innerHTML .= $element->ownerDocument->saveHTML($child);
    }
    return $innerHTML; 
}

// Get the feed first, pull out URLs for the articles
$feed = 'http://echo.msk.ru/programs/vsetak/rss-fulltext.xml';

$xml = DOMDocument::load($feed);
$xml_xpath = new DOMXPath($xml);

$links = $xml_xpath->query('//item/link');
$titles = $xml_xpath->query('//item/title');
$dates = $xml_xpath->query('//item/pubDate');

// Creating xml
$heading ="<item><title>";
$enddescr ="</description></item>";
$rssheader1 ="<?xml version=\"1.0\" encoding=\"UTF-8\"?><rss version=\"2.0\">\n<channel>\n<title>$titlenewsfeed</title>\n   
<link>$urlwebsite</link>
<description>$description</description>
<webMaster>$yourname</webMaster>
<language>ru</language>\n";
$rssfooter ="  \n</channel>\n</rss>\n";

echo $rssheader1;

for ($i = 0; $i < $links->length; $i++) {
  $url = $links->item($i)->nodeValue;
  $html = @DOMDocument::loadHTMLfile($url);
  $html_xpath = new DOMXPath($html);

  // Getting article full text
  $articles = $html_xpath->query('//div[@class="typical"]/span[@class="_ga1_on_ contextualizable"]');

  echo "<item><title>" . $titles->item($i)->nodeValue . "</title>";
  echo "<link>" . $links->item($i)->nodeValue . "</link>";
  echo "<description><![CDATA[" . DOMinnerHTML($articles->item(0)) . "]]></description>";
  echo "<pubDate>" . $dates->item($i)->nodeValue . "</pubDate>";
  echo "</item>";
}
echo $rssfooter;

?>
