<?php
// PHP script to parse poroshokuhodi.ru and produce rss feed from it's html.

// Feed settings
$titlenewsfeed="Порошки";
$urlwebsite="http://poroshokuhodi.ru/";
$description="Порошки. Кристаллизация поэзии";
$yourname="Darsh";
$url = 'https://twitter.com/poroshokuhodi';

// Inner HTML function
function DOMinnerHTML(DOMNode $element) {
    $innerHTML = "";
    $children  = $element->childNodes;
    foreach ($children as $child) {
        $innerHTML .= $element->ownerDocument->saveHTML($child);
    }
    return $innerHTML; 
}

$html = @DOMDocument::loadHTMLfile($url);

$xpath = new DOMXPath($html);

// Fetching elements for xml feed
$dates = $xpath->query('//small[@class="time"]/a');
$articles = $xpath->query('//p[@class="js-tweet-text tweet-text"]');
$links = $xpath->query('//a[@class="details with-icn js-details"]');

// Creating xml
$heading ="<item><title>";
$enddescr ="</description></item>";
$rssheader1 ="<?xml version=\"1.0\" encoding=\"UTF-8\"?><rss version=\"2.0\">\n<channel>\n<title>$titlenewsfeed</title>\n   
<link>$urlwebsite</link>
<description>$description</description>
<webMaster>$yourname</webMaster>
<language>ru</language>\n";
$rssfooter ="  \n</channel>\n</rss>\n";

echo $rssheader1;

for ($i = 0; $i < $articles->length; $i++) {
  echo "<item><title>";
  echo $dates->item($i)->getAttribute('title') . " ";
  echo mb_substr($articles->item($i)->nodeValue,0,64,'UTF-8');
  echo "</title>";
  echo "<link>" . 'https://twitter.com' . $links->item($i)->getAttribute('href') . "</link>";
  echo "<description><![CDATA[" . str_replace(" / ","<br>",DOMinnerHTML($articles->item($i))) . "\n" . "]]></description></item>";
}
echo $rssfooter;

?>
